/*
 * Copyright (c) 2023 Accso. All rights reserved.
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <iostream>
#include <string>
#include <stdio.h>
#include <unistd.h>

extern "C" {
#include "ftlock.h"
}
#include "ft.hpp"
#include "ftop.h"

using namespace ft;

#define SERVO_MIN 300UL
#define SERVO_MAX 2700UL

int main(int argc, char **argv)
{
    int servoNum = 1;
    int servoPos=1485;
    if (argc < 2)
    {
        printf("ERROR\n");
        return 1;
    }

    servoNum = atoi(argv[1]);
    servoPos = atoi(argv[2]);

    if ((servoNum < 1) || (servoNum > 3))
    {
        printf("ERROR\n");
        return 1;
    }

    if ((servoPos < SERVO_MIN) || (servoPos > SERVO_MAX))
    {
        printf("ERROR\n");
        return 1;
    }

    if (ftlock_open() < 0)
    {
        printf("ERROR\n");
        return 1;
    }
    TXT txt2;
    Servo s { txt2, servoNum };

    txt2.update_config();
    s.setPwmUs(servoPos);

    ftlock_unlock(); // can be skipped in this case
    ftlock_close();  // can be skipped in this case
    printf("OK\n");
    return 0;
}
